module(..., package.seeall)

local table             = require "hp/lang/table"
local class             = require "hp/lang/class"
local Event             = require "hp/event/Event"
local Component         = require "hp/gui/Component"

-- class define
local M                 = class(Component)
local super             = Component

function M:initInternal(params)
    super.initInternal(self, params)
end

function M:createChildren()
  printf("Progress Indicator Create children.")

  self:setLayout(HBoxLayout {
    align = {"center", "center"},
    padding = {0, 0, 0, 0},
    gap = {0, 0}    
  })  
  
  -- TODO - Make sure the texture is cached.
  self._dotsSheet = MOAITileDeck2D.new ()
  self._dotsSheet:setTexture ( '../assets/loading_dots.png' )
  self._dotsSheet:setSize (5, 1 )
  self._dotsSheet:setRect ( -256/10, 41/2, 256/10, -41/2 )
  
  self._dots = {}
  for index=1, 5 do
    local dotSprite = Sprite {
      parent = self,
    }
    dotSprite:setDeck(self._dotsSheet)
    dotSprite:setIndex(index)
    table.insert(self._dots, dotSprite)
    if(index > 1) then
      dotSprite:setColor(0,0,0,0)
    end
  end  
end

function M:updateLayout()
    super.updateLayout(self)
end

function M:startAnimation()
  if self._animation == nil then
    self._animation = Animation():loop(0, 
        Animation():sequence( Animation({self._dots[2], 
                                        self._dots[3],
                                        self._dots[4],
                                        self._dots[5],
                                }, 1):fadeOut(),
                  -- Animation(self:getChildren()[1], 1):fadeIn(),
                  Animation(self._dots[2], 0.6):fadeIn(),
                  Animation(self._dots[3], 0.6):fadeIn(),
                  Animation(self._dots[4], 0.6):fadeIn(),
                  Animation(self._dots[5], 0.6):fadeIn()))
  end             
  self._animation:play()
end

function M:stopAnimation()
  if(self._animation ~= nil) then
    self._animation:stop()
    self._animation = nil
  end
end

return M


