local table             = require "hp/lang/table"
local class             = require "hp/lang/class"
local Event             = require "hp/event/Event"
local Component         = require "hp/gui/Component"

-- class define
local M                 = class(Component)
local super             = Component

require "utilities"

function M:initInternal()
  super.initInternal(self)
end

function M:createChildren()
  self._bg = Graphics {
    parent = self
  }
  
  self._label = TextLabel()
  self._label:setText("Text on label")
  self._label:setParent(self)
  self._label:setRGBA(255,255,255,1)
  self._label:setAlignment(TextLabel.HORIZOTAL_ALIGNS.center, TextLabel.VERTICAL_ALIGNS.center)
  
end

function M:setText(text) 
  self._label:setText(text)
end  

function M:setTextSize(size)
  self._label:setTextSize(size)
end  

function M:setBgColor(r, g, b, a)
  print("setBgColor " .. r)
  self._penColorR = r
  self._penColorG = g
  self._penColorB = b
  self._penColorA = a
end  

function M:resizeHandler(e)
  self._label:setSize(self:getSize())
  self._bg:setSize(self:getSize())
end

function M:draw()
  self._bg:setPenColor(self._penColorR, self._penColorG, self._penColorB, self._penColorA):fillRoundRect(0,0, self:getWidth(), self:getHeight(), 10, 10, 30)
end  



return M